## otpw 1.3

=== Makefile ===
#
# Makefile - One-time password login capability
#
# Markus Kuhn <http://www.cl.cam.ac.uk/~mgk25/>
#
# $Id: Makefile,v 1.10 2003-09-30 21:14:27+01 mgk25 Rel $
#

VERSION=1.3

CC=gcc
CFLAGS=-O -ggdb -W -Wall

TARGETS=otpw-gen demologin pam_otpw.so

all: $(TARGETS)

otpw-gen: otpw-gen.o rmd160.o md.o
	$(CC) -o $@ $+
demologin: demologin.o otpw.o rmd160.o md.o
	$(CC) -o $@ $+ -lcrypt

otpw-gen.o: otpw-gen.c md.h conf.h
otpw.o: otpw.c otpw.h md.h conf.h
md.o: md.c md.h rmd160.h
rmd160.o: rmd160.c rmd160.h
otpw-l.o: otpw-l.c otpw.c otpw.h md.h conf.h
pam_otpw.o: pam_otpw.c otpw.h md.h conf.h
pam_otpw.so: pam_otpw.o otpw-l.o rmd160.o md.o
	ld --shared -o $@ $+ -lcrypt -lpam -lpam_misc

ship: all clean
	ci -sRel -l RCS/*
	cd .. ; tar cvf otpw-$(VERSION).tar --exclude otpw/RCS otpw ; \
	gzip -9 otpw-$(VERSION).tar
	mv ../otpw-$(VERSION).tar.gz ${HOME}/public_html/download/
	cp otpw.html otpw.html~
	mv otpw.html~ ${HOME}/public_html/otpw.html 

clean:
	rm -f $(TARGETS) *~ *.o core

## otpw 1.5

=== Makefile ===
#
# Makefile - One-time password login system
#
# Markus Kuhn <http://www.cl.cam.ac.uk/~mgk25/>
#

VERSION=1.5

CC=gcc
CFLAGS=-O -ggdb -W -Wall -Wno-unused-result -fPIC

%.gz: %
	gzip -9c $< >$@

TARGETS=otpw-gen demologin pam_otpw.so pam_otpw.8.gz otpw-gen.1.gz

all: $(TARGETS)

otpw-gen: otpw-gen.o rmd160.o md.o otpw.o
	$(CC) -o $@ $+
demologin: demologin.o otpw.o rmd160.o md.o
	$(CC) -o $@ $+ -lcrypt

otpw-gen.o: otpw-gen.c md.h otpw.h
otpw.o: otpw.c otpw.h md.h
md.o: md.c md.h rmd160.h
rmd160.o: rmd160.c rmd160.h
otpw-l.o: otpw-l.c otpw.c otpw.h md.h
pam_otpw.o: pam_otpw.c otpw.h md.h
pam_otpw.so: pam_otpw.o otpw-l.o rmd160.o md.o
	ld --shared -o $@ $+ -lcrypt -lpam -lpam_misc

distribution:
	git archive --prefix otpw-$(VERSION)/ -o otpw-$(VERSION).tar.gz v$(VERSION)

release:
	git diff --exit-code v$(VERSION) -- otpw.html
	rsync -t otpw-$(VERSION).tar.gz $(HOME)/public_html/download/
	rsync -t otpw.html $(HOME)/public_html/

#PAMLIB=/lib/security
PAMLIB=/lib/x86_64-linux-gnu/security

install: install-pam install-gen

install-pam: pam_otpw.so pam_otpw.8.gz
	rsync -t pam_otpw.so $(PAMLIB)/
	rsync -t pam_otpw.8.gz /usr/share/man/man8/
	perl -i.bak -pe 's/^(\@include common-auth)$$/\# $$1\nauth required pam_otpw.so/' /etc/pam.d/sshd
	perl -i.bak -pe 's/^(ChallengeResponseAuthentication\s+)no$$/$$1yes/' \
	  /etc/ssh/sshd_config
	killall -SIGHUP sshd

install-gen: otpw-gen otpw-gen.1.gz
	rsync -t otpw-gen /usr/bin/
	rsync -t otpw-gen.1.gz /usr/share/man/man1/
	-getent passwd otpw && \
	  chown otpw /usr/bin/otpw-gen && chmod u+s /usr/bin/otpw-gen

install-pseudouser:
	adduser --system --gecos 'Pseudouser for storing one-time password files' --home /var/lib/otpw otpw

uninstall-pseudouser:
	deluser --remove-home otpw

uninstall:
	rm -f $(PAMLIB)/pam_otpw.so /usr/share/man/man8/pam_otpw.8.gz
	rm -f /usr/bin/otpw-gen /usr/share/man/man1/otpw-gen.1.gz

clean:
	rm -f $(TARGETS) *~ *.o core

test-login:
	ssh -o PreferredAuthentications=keyboard-interactive localhost

=== debian/changelog ===
otpw (1.5-5) unstable; urgency=medium

  * add gcc15.patch (Closes: #1097531)
    (do really close this now)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 08 Sep 2025 10:22:19 +0200

otpw (1.5-4) unstable; urgency=medium

  * debian/control: bump standard to 4.7.2

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 07 Sep 2025 10:22:19 +0200

otpw (1.5-3) unstable; urgency=medium

  * debian/control: use dh 13
  * debian/control: bump standard to 4.7.0
  * debian/control: add Rules-Requires-Root: no
  * Install PAM module into /usr. (Closes: #1063622)
  * Use Multi-Arch paths.
    Thanks to Michael Biebl for the patch

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 29 May 2024 22:22:19 +0200

otpw (1.5-2) sid; urgency=medium

  * debian/control: use dh 11
  * debian/control: bump standard to 4.3.0
  * debian/control: add salsa VCS URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 05 Jan 2019 18:22:19 +0100

otpw (1.5-1) unstable; urgency=medium

  * new upstream version
  * adopt package (Closes: #762543)
  * apply patches from Jari Aalto (Closes: #669697)
  * apply patches from Ludovic Stordeur (Closes: #855938)
  * use dh 10
  * bump standard to 4.0.0
  * take care of hardening flags

  [Ludovic Stordeur]
  * New upstream release
  * Add patch: 01-fix-pam-otpw-linking
  * Add patch: 02-fix-pam-otpw-useless-deps
  * Add patch: 03-fix-makefile-pamlib-variable
  * Add patch: 04-fix-signed-vs-unsigned-comparison
  * Update to Standards-Version 3.9.6
  * Removed 01-pam-otpw-8.patch: applied upstream

  [Jari Aalto]
  * Remove deprecated dpatch and upgrade to packaging format "3.0 quilt".
  * Update to Standards-Version to 3.9.3 and debhelper to 9.
  * Add build-arch and build-indep targets; use dh_prep in rules file.
  * Fix copyright-refers-to-symlink-license (Lintian).
  * Fix copyright-with-old-dh-make-debian-copyright (Lintian).
  * Fix binary-control-field-duplicates-source (Lintian).
  * Fix debian-rules-ignores-make-clean-error (Lintian).
  * Fix no-homepage-field (Lintian).
  * Fix debian-watch-contains-dh_make-template (Lintian).

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 23 Jun 2017 18:22:19 +0200

otpw (1.3-2) unstable; urgency=low

  * Update maintainer address

 -- Matthew Johnson <mjj29@debian.org>  Wed, 05 Dec 2007 10:26:26 +0000

otpw (1.3-1) unstable; urgency=low

  * Initial release (Closes: #414686)
  * Patch pam_otpw.8 to be in section 8
  * Clarify licence

 -- Matthew Johnson <debian@matthew.ath.cx>  Sun, 29 Jul 2007 11:27:43 +0100

=== debian/control ===
Source: otpw
Priority: optional
Section: libs
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, libpam-dev
Standards-Version: 4.7.2
#Testsuite: autopkgtest
Homepage: https://www.cl.cam.ac.uk/~mgk25/otpw.html
Vcs-Browser: https://salsa.debian.org/alteholz/otpw
Vcs-Git: https://salsa.debian.org/alteholz/otpw.git
Rules-Requires-Root: no

Package: libotpw-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}
Recommends: otpw-bin
Multi-Arch: same
Description: OTPW library development files and documentation
 OTPW is a one-time password system which is robust against
 the password list being stolen and race for the last digit
 attacks.
 .
 This package contains the development files needed to write
 programs using OTPW and the documentation of the OTPW system.

Package: libpam-otpw
Architecture: any
Recommends: otpw-bin
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Use OTPW for PAM authentication
 OTPW is a one-time password system which is robust against
 the password list being stolen and race for the last digit
 attacks.
 .
 This package contains the PAM library to use OTPW in any
 program which uses PAM.

Package: otpw-bin
Section: admin
Architecture: any
Suggests: libpam-otpw
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OTPW programs for generating OTPW lists
 OTPW is a one-time password system which is robust against
 the password list being stolen and race for the last digit
 attacks.
 .
 This package contains the programs used to setup OTPW for
 a user and generate the password lists.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

include /usr/share/dpkg/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

HCFLAGS=$(shell dpkg-buildflags --get CFLAGS)
HCPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
HLDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

build-arch: build
build-indep: build

build: build-stamp
build-stamp:
	dh_testdir
	
	# Add here commands to compile the package.
	$(MAKE) CFLAGS="-fPIC -O -ggdb -W -Wall $(HCFLAGS) $(HCPPFLAGS)" LDFLAGS="$(HLDFLAGS) -Wl,-z,now" otpw-gen pam_otpw.so
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	
	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean
	
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	# Add here commands to install the package into debian/tmp
	mkdir -p debian/tmp
	install -d debian/tmp/usr/bin
	install otpw-gen debian/tmp/usr/bin
	install -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/security
	install pam_otpw.so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/security
	install -d debian/tmp/usr/include
	install -m644 otpw.h debian/tmp/usr/include
	install -d debian/tmp/usr/lib

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installman
	dh_install --sourcedir=debian/tmp
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=4
https://www.cl.cam.ac.uk/~mgk25/download/otpw-([\.0-9]*)\.tar\.gz
